<template>
  <div class="order-card-left-side">
    <div
      class='info'
      :class="[ !selectedSubOrder && '--active' ]"
      @click="onSelectSubOrder(null)"
    >
      <div class='info__line'>
        <span class='info__number'>
          <ObTooltip
            v-if="order.isEditable !== undefined && !order.isEditable"
            :content="$options.textContent.isEditableIconTooltip"
          >
            <i class="icon lock" />
          </ObTooltip>
          <span>{{ order.number }}</span>
        </span>
        <div class='info__status'>
          <div class="d-f al-i-c">
            {{ orderCondition }}
          </div>
          <span class="info__status-value">
            {{ order.statusTitle }}
          </span>
        </div>
      </div>
      <div class='info__line'>
        <span>Себестоимость заказа</span>
        <span class="info__line-value">
          {{ order.costAccuracy ? '' : '~' }}{{ (order.costPrice / 100 ) | currency({ dot: 2 }) }} ₽
        </span>
      </div>
      <div class='info__line'>
        <span>Маржа</span>
        <div>
          <span class="info__line-value" :class="getMarginClass()">
            {{ order.marginInPercent | currency({ dot: 2 }) }}%
          </span>
          <span class="info__line-value" :class="getMarginClass()">
            {{ (order.margin / 100) | currency({ dot: 2 }) }} ₽
          </span>
        </div>
      </div>
      <div class='info__line'>
        <span>Ответственный</span>
        <span class="info__line-value">
          {{ order.logistTitle }}
        </span>
      </div>
    </div>

    <transition name="fadeIn">
      <div
        v-if="showConfirmExtraServices"
        class="alert"
      >
        <ObAlert
          theme="warning"
          theme-icon="warning"
          icon="alert"
          :hide-close-button="true"
        >
          У вас есть услуги которые вы можете подтвердить
        </ObAlert>
      </div>
    </transition>

    <div class='route'>
      <h3 class="route__title">Заказы перевозчикам</h3>
      <div
        v-for="(group, index) in currentSubOrders"
        v-show="group.items.length"
        :key="index"
        class="route__group"
      >
        <div class='route__points'>
          {{ group.title }}
        </div>
        <div
          ref="pointsList"
          class="route__points-list"
        >
          <div
            v-for="(item, index) in group.items"
            class='route__details'
            :class="routeItemClass(item, index, group.items)"
            :key="index"
            @click="onSelectSubOrder(item)"
          >
            <div class="icon-container">
              <template v-if="item.subOrderType === 'AUTO'">
                <template v-if="order.transportationWay === 'CONTAINER'">
                  <svg width="42" height="18" viewBox="0 0 42 18" fill="none" xmlns="http://www.w3.org/2000/svg">
                    <g opacity="0.5" clip-path="url(#clip0)">
                      <path fill-rule="evenodd" clip-rule="evenodd" d="M36.556 18C37.8616 18 38.9861 17.214 39.4457 16.1085C40.5206 16.0436 41.1695 15.8043 41.4203 15.7118C41.4824 15.6889 41.5201 15.675 41.5338 15.675C41.8449 15.525 42.0004 15.3 42.0004 15V8.925C41.6893 6.6 41.0671 2.55001 40.2115 1.72501C39.0449 0.600014 32.9004 0 31.8893 0C31.4227 0 31.1115 0.3 31.1115 0.75C31.1115 1.2 31.4227 1.5 31.8893 1.5C33.6004 1.5 38.5004 2.25001 39.1227 2.77501C39.3232 3.04578 39.5859 4.01484 39.8359 5.25H37.3338C36.8671 5.25 36.556 5.55 36.556 6V7.72501C36.556 8.02501 36.7893 8.32501 37.1004 8.40001L40.4449 9.49529V11.25C39.9782 11.25 39.6671 11.55 39.6671 12C39.6671 12.45 39.9782 12.75 40.4449 12.75V14.475C40.2562 14.5205 39.9816 14.566 39.6386 14.5947C39.4318 13.1346 38.1246 12 36.556 12C34.8449 12 33.4449 13.35 33.4449 15H26.4449C26.4449 14.4546 26.2919 13.9419 26.0253 13.5H31.8893C32.356 13.5 32.6671 13.125 32.6671 12.75V3.75C32.6671 3.3 32.356 3 31.8893 3C31.4227 3 31.1115 3.3 31.1115 3.75V12H23.3338C21.6227 12 20.2227 13.35 20.2227 15C20.2227 16.65 21.6227 18 23.3338 18C24.4794 18 25.4856 17.3948 26.0255 16.4996C26.0318 16.4997 26.0381 16.4999 26.0445 16.4999C26.0483 16.5 26.0521 16.5 26.056 16.5H33.8645C34.4044 17.395 35.4105 18 36.556 18ZM23.3338 13.5C22.4782 13.5 21.7782 14.175 21.7782 15C21.7782 15.825 22.4782 16.5 23.3338 16.5C24.1893 16.5 24.8893 15.825 24.8893 15C24.8893 14.175 24.1893 13.5 23.3338 13.5ZM36.556 13.5C35.7004 13.5 35.0004 14.175 35.0004 15C35.0004 15.825 35.7004 16.5 36.556 16.5C37.4115 16.5 38.1115 15.825 38.1115 15C38.1115 14.175 37.4115 13.5 36.556 13.5Z" fill="#0070A6"/>
                      <path d="M14.7778 10.5C14.3111 10.5 14 10.2 14 9.75V3.75C14 3.3 14.3111 3 14.7778 3C15.2444 3 15.5556 3.3 15.5556 3.75V9.75C15.5556 10.125 15.2444 10.5 14.7778 10.5Z" fill="#0070A6"/>
                      <path d="M18.6667 9.75C18.6667 10.2 18.9778 10.5 19.4444 10.5C19.9111 10.5 20.2222 10.125 20.2222 9.75V3.75C20.2222 3.3 19.9111 3 19.4444 3C18.9778 3 18.6667 3.3 18.6667 3.75V9.75Z" fill="#0070A6"/>
                      <path d="M10.1111 10.5C9.64445 10.5 9.33333 10.2 9.33333 9.75V3.75C9.33333 3.3 9.64445 3 10.1111 3C10.5778 3 10.8889 3.3 10.8889 3.75V9.75C10.8889 10.125 10.5778 10.5 10.1111 10.5Z" fill="#0070A6"/>
                      <path d="M4.66667 9.75C4.66667 10.2 4.97778 10.5 5.44444 10.5C5.91111 10.5 6.22222 10.125 6.22222 9.75V3.75C6.22222 3.3 5.91111 3 5.44444 3C4.97778 3 4.66667 3.3 4.66667 3.75V9.75Z" fill="#0070A6"/>
                      <path fill-rule="evenodd" clip-rule="evenodd" d="M6.5804 13.5C6.84702 13.9419 7 14.4546 7 15C7 16.65 5.6 18 3.88889 18C2.17778 18 0.777778 16.65 0.777778 15C0.777778 14.4546 0.930754 13.9419 1.19738 13.5H0.777778C0.311111 13.5 0 13.2 0 12.75V0.75C0 0.3 0.311111 0 0.777778 0H24.8889C25.3556 0 25.6667 0.3 25.6667 0.75V12.75C25.6667 13.125 25.3556 13.5 24.8889 13.5H12.8026C13.0692 13.9419 13.2222 14.4546 13.2222 15C13.2222 16.65 11.8222 18 10.1111 18C8.4 18 7 16.65 7 15C7 14.4546 7.15298 13.9419 7.4196 13.5H6.5804ZM1.55556 12V1.5H24.1111V12H1.55556ZM10.1111 13.5C9.25556 13.5 8.55556 14.175 8.55556 15C8.55556 15.825 9.25556 16.5 10.1111 16.5C10.9667 16.5 11.6667 15.825 11.6667 15C11.6667 14.175 10.9667 13.5 10.1111 13.5ZM2.33333 15C2.33333 14.175 3.03333 13.5 3.88889 13.5C4.74444 13.5 5.44444 14.175 5.44444 15C5.44444 15.825 4.74444 16.5 3.88889 16.5C3.03333 16.5 2.33333 15.825 2.33333 15Z" fill="#0070A6"/>
                    </g>
                    <defs>
                      <clipPath id="clip0">
                        <rect width="42" height="18" fill="white"/>
                      </clipPath>
                    </defs>
                  </svg>
                </template>
                <template v-else>
                  <i class="icon tractor-semi-trailer-izoterm-b" />
                </template>
              </template>
              <template v-else-if="item.subOrderType === 'TRAIN'">
                <template v-if="order.transportationWay === 'CONTAINER'">
                  <svg width="40" height="18" viewBox="0 0 40 18" fill="none" xmlns="http://www.w3.org/2000/svg">
                    <path opacity="0.5" fill-rule="evenodd" clip-rule="evenodd" d="M8.14815 11.25H1.48148V12.75H38.5185V10.5C38.5185 10.05 38.8148 9.75 39.2593 9.75C39.7037 9.75 40 10.05 40 10.5V12.75C40 13.575 39.3333 14.25 38.5185 14.25H36.4936C36.8344 14.6435 37.037 15.1652 37.037 15.75C37.037 17.025 36.0741 18 34.8148 18C33.8173 18 33.0056 17.3881 32.7114 16.5H30.9923C30.6981 17.3881 29.8864 18 28.8889 18C27.6296 18 26.6667 17.025 26.6667 15.75C26.6667 15.1652 26.8693 14.6435 27.2101 14.25H12.7899C13.1307 14.6435 13.3333 15.1652 13.3333 15.75C13.3333 17.025 12.3704 18 11.1111 18C10.1136 18 9.30194 17.3881 9.00768 16.5H7.28862C6.99435 17.3881 6.18274 18 5.18518 18C3.92593 18 2.96296 17.025 2.96296 15.75C2.96296 15.1652 3.16557 14.6435 3.50645 14.25H1.48148C0.666667 14.25 0 13.575 0 12.75V10.5C0 10.05 0.296296 9.75 0.740741 9.75H7.40741V0.75C7.40741 0.3 7.7037 0 8.14815 0H31.1111C31.5556 0 31.8519 0.3 31.8519 0.75V9.75H36.2963C36.7407 9.75 37.037 10.05 37.037 10.5C37.037 10.95 36.7407 11.25 36.2963 11.25H31.1111H8.14815ZM30.3704 9.75V1.5H8.88889V9.75H11.8519V3.75C11.8519 3.3 12.1481 3 12.5926 3C13.037 3 13.3333 3.3 13.3333 3.75V9.75H16.2963V3.75C16.2963 3.3 16.5926 3 17.037 3C17.4815 3 17.7778 3.3 17.7778 3.75V9.75H20.7407V3.75C20.7407 3.3 21.037 3 21.4815 3C21.9259 3 22.2222 3.3 22.2222 3.75V9.75H25.1852V3.75C25.1852 3.3 25.4815 3 25.9259 3C26.3704 3 26.6667 3.3 26.6667 3.75V9.75H30.3704ZM9.43237 14.25C9.24594 14.4652 9.10087 14.7187 9.00768 15H7.28862C7.19543 14.7187 7.05036 14.4652 6.86392 14.25H9.43237ZM32.7114 15C32.8046 14.7187 32.9496 14.4652 33.1361 14.25H30.5676C30.7541 14.4652 30.8991 14.7187 30.9923 15H32.7114ZM34.0741 15.75C34.0741 15.3 34.3704 15 34.8148 15C35.2593 15 35.5556 15.3 35.5556 15.75C35.5556 16.2 35.2593 16.5 34.8148 16.5C34.3704 16.5 34.0741 16.2 34.0741 15.75ZM28.8889 15C28.4444 15 28.1481 15.3 28.1481 15.75C28.1481 16.2 28.4444 16.5 28.8889 16.5C29.3333 16.5 29.6296 16.2 29.6296 15.75C29.6296 15.3 29.3333 15 28.8889 15ZM11.1111 15C10.6667 15 10.3704 15.3 10.3704 15.75C10.3704 16.2 10.6667 16.5 11.1111 16.5C11.5556 16.5 11.8519 16.2 11.8519 15.75C11.8519 15.3 11.5556 15 11.1111 15ZM4.44444 15.75C4.44444 15.3 4.74074 15 5.18518 15C5.62963 15 5.92593 15.3 5.92593 15.75C5.92593 16.2 5.62963 16.5 5.18518 16.5C4.74074 16.5 4.44444 16.2 4.44444 15.75Z" fill="#0070A6"/>
                  </svg>
                </template>
                <template v-else>
                  <i class="icon railway-carriage-refrigerator" />
                </template>
              </template>
              <template v-else-if="item.typeTitle">
                <div
                  :title="item.typeTitle"
                  class="service-title"
                >
                  {{ item.typeTitle }}
                </div>
              </template>
            </div>
            <div
              class='route__details-number'
            >
              <div>
                <div class="route__details-number-container">
                  <ObTooltip
                    v-if="item.isEditable !== undefined && !item.isEditable"
                    :content="$options.textContent.isEditableIconTooltip"
                  >
                    <i class="icon lock" />
                  </ObTooltip>
                  <span>{{ item.number }}</span>
                </div>
                <div class="route__details-number-desc --ellipsis">{{ item.contractorTitle }}</div>
              </div>
              <div class='route__status'>
                <template v-if="['NEW','ON_DOER_SEARCH'].includes(item.status)">
                  Поиск...
                </template>
                <template v-else-if="item.status === 'DRAFT'">
                  Назнач...
                </template>
                <template v-else-if="item.status === 'BOOKED' || item.status === 'ALLOCATED'">
                  <svg width="11" height="10" viewBox="0 0 11 10" fill="none" xmlns="http://www.w3.org/2000/svg">
                    <path fill-rule="evenodd" clip-rule="evenodd" d="M10.6332 0.199103C11.0469 0.51997 11.1219 1.11511 10.8007 1.52839L4.50181 9.63362C4.33179 9.85239 4.07446 9.98587 3.79753 9.99894C3.52061 10.012 3.25182 9.90336 3.06192 9.70157L0.257407 6.72153C-0.101332 6.34034 -0.0828355 5.74079 0.29872 5.38239C0.680276 5.024 1.2804 5.04248 1.63914 5.42367L3.68394 7.59643L9.30266 0.366428C9.62384 -0.0468497 10.2195 -0.121764 10.6332 0.199103Z" fill="#10CF96"/>
                  </svg>
                </template>
                <template v-else-if="item.status === 'CONTRACTED'">
                  <svg width="16" height="9" viewBox="0 0 16 9" fill="none" xmlns="http://www.w3.org/2000/svg">
                    <path fill-rule="evenodd" clip-rule="evenodd" d="M10.9502 0.189844C11.3611 0.495162 11.4349 1.06063 11.115 1.45286L5.24375 8.65283C5.07472 8.86011 4.81926 8.98656 4.54439 8.99899C4.26953 9.01143 4.00269 8.90861 3.81388 8.71752L0.256942 5.11753C-0.10033 4.75594 -0.0828772 4.18634 0.295925 3.84529C0.674726 3.50425 1.27143 3.52091 1.6287 3.8825L4.43119 6.71891L9.62704 0.34721C9.94689 -0.0450193 10.5393 -0.115474 10.9502 0.189844ZM15.6363 0.189844C16.0472 0.495162 16.121 1.06063 15.8011 1.45286L9.92986 8.65283C9.76083 8.86011 9.50537 8.98656 9.2305 8.99899C8.95564 9.01143 8.6888 8.90861 8.49999 8.71752L7.61076 7.81752C7.25348 7.45593 7.27094 6.88633 7.64974 6.54528C8.02854 6.20424 8.62525 6.2209 8.98252 6.58249L9.1173 6.71891L14.3132 0.34721C14.633 -0.0450193 15.2254 -0.115474 15.6363 0.189844Z" fill="#10CF96"/>
                  </svg>
                </template>
                <template v-else-if="item.status === 'IN_PROCESS'">
                  <svg width="21" height="8" viewBox="0 0 21 8" fill="none" xmlns="http://www.w3.org/2000/svg">
                    <g filter="url(#filter0_i)">
                      <rect width="21" height="8" rx="2" fill="#C4D5ED" fill-opacity="0.5"/>
                    </g>
                    <mask id="mask0" mask-type="alpha" maskUnits="userSpaceOnUse" x="0" y="0" width="21" height="8">
                      <rect width="21" height="8" rx="2" fill="white"/>
                    </mask>
                    <g mask="url(#mask0)">
                      <path d="M0 0.35C0 0.1567 0.1567 0 0.35 0C0.5433 0 0.7 0.1567 0.7 0.35V7.65C0.7 7.8433 0.5433 8 0.35 8C0.1567 8 0 7.8433 0 7.65V0.35Z" fill="#10CF96"/>
                    </g>
                    <defs>
                      <filter id="filter0_i" x="0" y="0" width="21" height="9" filterUnits="userSpaceOnUse" color-interpolation-filters="sRGB">
                        <feFlood flood-opacity="0" result="BackgroundImageFix"/>
                        <feBlend mode="normal" in="SourceGraphic" in2="BackgroundImageFix" result="shape"/>
                        <feColorMatrix in="SourceAlpha" type="matrix" values="0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 127 0" result="hardAlpha"/>
                        <feOffset dy="1"/>
                        <feGaussianBlur stdDeviation="1"/>
                        <feComposite in2="hardAlpha" operator="arithmetic" k2="-1" k3="1"/>
                        <feColorMatrix type="matrix" values="0 0 0 0 0 0 0 0 0 0.294 0 0 0 0 0.784 0 0 0 0.2 0"/>
                        <feBlend mode="normal" in2="shape" result="effect1_innerShadow"/>
                      </filter>
                    </defs>
                  </svg>
                </template>
                <template v-else-if="['PROCESSED', 'EXECUTION_CONFIRMED', 'INVOICING', 'INVOICED', 'PAY_PROCESS', 'PAID'].includes(item.status)">
                  <svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg">
                    <path fill-rule="evenodd" clip-rule="evenodd" d="M2.71236 3.6438L6.53487 14.6004L5.40509 15L1.58259 4.04343L2.71236 3.6438Z" fill="#0FB785"/>
                    <path d="M14.439 1L13.5567 1.77155C13.5567 1.77155 12.2622 2.83827 10.9706 2.83827C10.3814 2.83827 9.91125 2.59862 9.32206 2.3619C8.67482 2.06672 7.91148 1.65172 6.79404 1.65172C3.61587 1.65172 1.79315 3.6069 1.67415 3.72672L1.5 3.90207L4.55916 12.5498L5.20351 11.8981C5.20351 11.8981 6.61699 10.4778 8.02757 10.4778C8.90991 10.4778 9.44106 10.656 9.91125 10.7729C10.3814 10.8928 10.8516 11.071 11.5569 11.071C12.9704 11.071 14.1459 10.4193 14.204 10.4193L14.5 10.241L14.439 1ZM13.3216 9.53087C12.9704 9.70622 12.2622 9.94586 11.4989 9.94586C10.9706 9.94586 10.6165 9.82604 10.1464 9.70622C9.55716 9.53086 8.97086 9.35259 7.91148 9.35259C6.73309 9.35259 5.61565 10.0628 4.96841 10.5362L2.79448 4.20017C3.32273 3.72672 4.73331 2.71845 6.85209 2.71845C7.67638 2.71845 8.26267 3.01362 8.90991 3.31172C9.55716 3.6069 10.1464 3.90207 11.0287 3.90207C11.911 3.90207 12.7934 3.54845 13.3826 3.1919V9.53087H13.3216Z" fill="#0FB785"/>
                    <path d="M2.14748 4.02189C2.14748 4.02189 3.02982 3.07498 4.26335 2.65999L5.20374 5.02724C5.20374 5.02724 4.02825 5.44223 3.02982 6.39206L2.14748 4.13879V4.02189ZM5.14569 5.08861L6.14703 7.63413C6.14703 7.63413 6.91037 7.33896 7.44151 7.33896C7.96976 7.33896 8.498 7.39741 8.498 7.39741L7.79271 4.67361C7.79271 4.67361 7.61566 4.67361 7.32252 4.67361C6.14703 4.67361 5.14569 5.08861 5.14569 5.08861ZM3.97021 9.11586L4.7945 11.4831C4.7945 11.4831 5.96998 10.3579 7.02937 10.0628L6.08608 7.63413C5.08764 8.04913 3.97021 9.11586 3.97021 9.11586Z" fill="#0FB785"/>
                    <path d="M7.1451 2.18654L7.79271 4.67361C8.32385 4.67361 9.79212 5.38379 9.79212 5.38379L9.20583 2.77689C8.90978 2.71844 8.02744 2.24499 7.1451 2.18654ZM8.49764 7.45586L9.20583 10.0628C9.55703 10.0628 10.5584 10.4778 10.9705 10.4778L10.3813 7.92931C9.79212 7.75396 8.90978 7.45586 8.49764 7.45586ZM9.79212 5.44224L10.3233 7.87086C10.3233 7.87086 10.8515 7.99069 11.2637 7.99069C11.6758 7.99069 12.146 7.92931 12.146 7.92931L11.9689 5.67897C11.9689 5.67897 11.6178 5.79879 11.1447 5.79879C10.4974 5.79879 9.79212 5.44224 9.79212 5.44224ZM11.7919 3.25034L11.9689 5.67897C11.9689 5.67897 12.8513 5.44224 13.8526 4.67361V2.18654C12.7352 3.07499 11.7919 3.25034 11.7919 3.25034ZM12.146 7.92931C12.146 7.92931 13.0283 7.75396 13.8526 7.28051V9.94586C12.9703 10.3579 12.323 10.4778 12.323 10.4778L12.146 7.92931Z" fill="#0FB785"/>
                  </svg>
                </template>
                <template v-else-if="item.status === 'CANCELED'">
                  <span class="-light-raspberry-red">отмена</span>
                </template>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import { mapGetters, mapActions } from 'vuex'
  import { formatNumber } from 'common-components/src/helpers/common'
  import ObTooltip from 'common-components/src/obComponents/obTooltip'
  import ObAlert from 'common-components/src/obComponents/obAlert'
  import { textContent } from '@/constants/order'

  export default {
    name: 'OrderCardLeftSide',
    components: {
      ObTooltip,
      ObAlert
    },
    textContent,
    computed: {
      ...mapGetters({
        order: 'order/order',
        isClicar: 'user/isClicar',
        subOrders: 'order/subOrders',
        subOrder: 'order/subOrder',
        selectedSubOrder: 'order/selectedSubOrder',
        additionalServices: 'order/additionalServices',
        contractorUuid: 'user/participantUuid'
      }),
      currentSubOrders () {
        let result = {}

        this.subOrders.forEach((order) => {
          let title
          let group
          if (['logchainService', 'logchainOrderService'].includes(order.species)) {
            title = 'общие услуги'
            group = 0
          } else if (order.species === 'shipmentPointOrderService') {
            title = order.startPointTitle || order.endPointTitle
            group = order.groupOrdinal
          } else {
            title = order.startPointTitle + ' → ' + order.endPointTitle
            group = order.groupOrdinal
          }

          if (!result[group]) {
            result[group] = {
              title,
              items: []
            }
          }

          result[group].items.push(order)
        })

        for (let key in result) {
          result[key].items = result[key].items.sort((a, b) => {
            const sortA = this.getOrderSortIndex(a)
            const sortB = this.getOrderSortIndex(b)

            return sortA - sortB
          })
        }

        return result
      },
      orderCondition() {
        if (!this.order || !this.order.orderCondition) return ''

        switch (this.order.orderCondition) {
          case 'QUOTA': return 'Квота'
          case 'SPOT': return 'Спот'
          default: return ''
        }
      },
      showConfirmExtraServices () {
        let uuids = Object.keys(this.additionalServices)

        return Object.values(this.additionalServices).some((services, index) => {
          const isSuborder = this.order.isSuborder || uuids[index] !== this.order.uuid

          return services.some(service => {
            return service.status === 'NEW' && (service.creatorUuid !== this.contractorUuid || !isSuborder)
          })
        })
      }
    },
    methods: {
      ...mapActions({
        selectSubOrder: 'order/selectSubOrder'
      }),
      onSelectSubOrder (data) {
        this.$router.replace({ query: { ...this.$route.query, suborder: data ? data.uuid : undefined, trip: undefined, tab: undefined } })
        this.selectSubOrder(data)
      },
      getOrderSortIndex (data) {
        let index

        if (data.species === 'order') {
          if (data.status === 'CANCELED') {
            index = 1
          } else {
            index = 0
          }
        } else {
          index = 2
        }

        return index
      },
      getMarginClass () {
        if (!this.order.totalPrice) return ''
        let className
        if (this.subOrder.executor) {
          className = (this.order.totalPrice - this.subOrder.totalPrice) >= 0 ? '-caribbean-green' : '-light-raspberry-red'
        } else {
          className = this.order.margin >= 0 ? '-caribbean-green' : '-light-raspberry-red'
        }
        return className
      },
      routeItemClass (item, index, orders) {
        const subCanceled = item.status === 'CANCELED' && orders.some((orderItem) => orderItem.uuid !== item.uuid && orderItem.tripUuid === item.tripUuid)
        const isService = item.species === 'legOrderService'

        return {
          '--active': this.selectedSubOrder && this.selectedSubOrder.uuid === item.uuid && this.selectedSubOrder.species === item.species,
          '--sub-canceled': subCanceled,
          '--canceled': item.status === 'CANCELED' && !subCanceled,
          '--last-top-item': !isService && !subCanceled && (!orders[index + 1] || orders.slice(index + 1).every((orderItem) => orderItem.status === 'CANCELED' || orderItem.species === 'legOrderService')),
          '--is-service': isService
        }
      },
      formatNumber
    }
  }
</script>

<style lang="scss" scoped>
  @import '~common-components/src/static/css/variables';
  @import '~common-components/src/static/css/mixins';

  .order-card-left-side {
    position: relative;
    z-index: 20;
    width: 316px;
    flex-shrink: 0;
    box-shadow: 0px 2px 10px rgba($color-blue-navy-blue, 0.15);

    .info {
      width: 316px;
      min-height: 166px;
      padding: 16px 20px 20px;
      background-color: $background-white;
      color: $color-text-base;
      cursor: pointer;
      border-bottom: 1px solid $color-grey-border;
      &__number {
        margin: 0;
        @include font-mixin(20px, 24px, 600, $color-text-base, 0.8px);
        .icon {
          font-size: 17px;
          color: $color-blue-navy-blue;
          margin-right: 5px;
        }
      }
      &__status {
        display: flex;
        flex-direction: column;
        align-items: flex-end;
        @include font-mixin(10px, 12px, 400, $color-text-base, 0.4px);

        &-value {
          @include font-mixin(10px, 12px, 400, $color-text-base, 0.4px);
          text-align: right;
        }

        .icon {
          color: $color-blue-navy-blue;
          margin-left: 5px;
          font-weight: bold;
        }
      }
      &__line {
        display: flex;
        justify-content: space-between;
        margin-bottom: 5px;
        &:last-child {
          margin-bottom: 0;
        }
        @include font-mixin(12px, 20px, 400, $color-grey-label, 0.4px);

        &:first-child {
          align-items: flex-end;
        }
        &-value {
          margin-left: 20px;
          text-align: right;
          @include font-mixin(14px, 20px, 400, $color-text-base, 0.2px);
        }

        &-value + .info__line-value {
          margin-left: 10px;
        }

        .--success {
          .info__line-value {
            color: $color-green-light!important;
          }
        }
      }

      &.--active {
        border-color: $color-blue-navy-blue;
        background-color: $color-blue-navy-blue;
        color: white;
        cursor: default;
        .info__line {
          color: $cornflower-craiola;
          .info__line-value {
            color: $components-LeftSide-left_side_info_active_value;
          }
        }
        .info__number {
          color: $components-LeftSide-left_side_info_number;
          .icon {
            color: #fff;
          }
        }
        .info__status {
          color: $style-white;
          .info__status-value, .icon {
            color: $components-LeftSide-left_side_info_status_value_icon;
          }
        }
      }
    }

    .alert {
      padding: 21px 21px 0;
      border-bottom: 1px solid $color-grey-border;
      &__text {
        color: $color-blue-navy-blue;
        cursor: pointer;
      }
    }

    .route {
      padding: 20px 16px 28px 20px;
      border-bottom: 1px solid $color-grey-border;
      &__title {
        margin-bottom: 20px;
        @include font-mixin(16px, 24px, 700, $color-text-base, 0.4px);
      }
      &__points {
        @include font-mixin(10.5px, 20px, 400, $color-grey-span, 0.4px, uppercase);
      }
      &__group {
        &:not(:last-child) {
          margin-bottom: 24px;
        }
      }
      &__points-list {
        overflow: hidden;
        margin-top: 5px;
        margin-left: 5px;
        background-image: linear-gradient(to top, $color-grey-border 66%, rgba(255,255,255,0) 0%);
        background-position: left;
        background-size: 1.5px 5px;
        background-repeat: repeat-y;
      }
      &__details {
        position: relative;
        padding-left: 20px;
        padding-top: 12px;
        display: flex;
        cursor: pointer;
        &:before {
          content: '';
          width: 12px;
          height: 2px;
          background-image: linear-gradient(to left, $color-grey-border 66%, rgba(255,255,255,0) 0%);
          background-position: bottom;
          background-size: 4px 2px;
          background-repeat: repeat-x;
          position: absolute;
          left: 0;
          top: 16px;
        }

        &.--last-top-item {
          &::after {
            content: '';
            position: absolute;
            top: 18px;
            left: 0;
            width: 2px;
            height: 1000px;
            background-color: #fff;
          }
        }
        &.--is-service {
          &::before {
            left: 40px;
            top: -8px;
            width: 2px;
            height: 12px;
            background-repeat: repeat-y;
            background-position: left;
            background-size: 1.5px 4px;
            background-image: linear-gradient(to top, $color-grey-border 66%, rgba(255,255,255,0) 0%);
          }
        }

        &.--sub-canceled {
          padding-top: 10px;
          .route__details-number {
            padding: 6px;
            @include font-mixin(12px, 10px, 400, $color-grey-span, 0.4px);
            text-decoration: line-through;
          }
          &::before, .route__details-number-desc {
            display: none;
          }
          .route__status, & > .icon {
            opacity: 0;
          }
          .icon-container {
            .icon, svg {
              opacity: 0;
            }
          }
        }

        .icon {
          font-size: 18px;
          color: $cornflower-craiola;
        }

        .icon-container {
          width: 61px;
        }

        .service-title {
          max-width: 60px;
          -webkit-line-clamp: 2;
          -webkit-box-orient: vertical;
          overflow: hidden;
          text-overflow: ellipsis;
          transform: translateY(-2px);
          @include font-mixin(9px, 12px, 400, $color-grey-span, 0.1px, uppercase);
        }

        &-number {
          display: flex;
          margin-left: 5px;
          margin-top: -6px;
          padding: 2px 6px 5px 6px;
          border-radius: 3px;
          flex-grow: 2;
          justify-content: space-between;
          @include font-mixin(16px, 24px, 400, $color-blue-navy-blue, 0.8px);

          &-container {
            display: flex;
            align-items: center;
            max-width: 121px;
            span {
              position: relative;
              top: 1px;
              white-space: nowrap;
              overflow: hidden;
              text-overflow: ellipsis;
            }
            .icon {
              margin-right: 4px;
              font-size: 16px;
              color: $color-blue-navy-blue;
            }
          }

          &-desc {
            margin-top: 4px;
            @include font-mixin(10px, 12px, 400, $color-grey-span, 0.1px, uppercase);
            font-variant: small-caps;
            & + .route__details-number-desc {
              margin-top: 7px;
            }
          }
        }

        &.--active {
          cursor: default;
          .route__details-number {
            background-color: $color-blue-navy-blue;
            color: $components-LeftSide-left_route_details_active_number;
            &-desc {
              color: $components-LeftSide-left_route_details_active_number_desc;
            }
          }
          .route__details-number-container {
            .icon {
              color: #fff;
            }
          }
          .route__status {
            color: #fff;
            .icon {
              color: #fff;
            }
            path {
              fill: #fff!important;
            }
          }
        }
      }
      &__status {
        flex-grow: 2;
        margin-left: 5px;
        margin-top: 6px;
        text-align: right;
        @include font-mixin(8px, 10px, 400, $color-grey-span, 0.1px, uppercase);
      }

      .--ellipsis {
        max-width: 130px;
        white-space: nowrap;
        overflow: hidden;
        text-overflow: ellipsis;
      }
    }

    .fadeIn-enter,
    .fadeIn-leave-to {
      opacity: 0;
    }

    .fadeIn-enter-active,
    .fadeIn-leave-active {
      transition: opacity .3s ease-in-out;
    }
  }
</style>
